function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
import Vue from 'Vue';
function AngularVueRoutePlugin($injector) {
  var _Vue$prototype, _Vue$prototype$$ngVue;
  if (!$injector) $injector = Vue === null || Vue === void 0 ? void 0 : (_Vue$prototype = Vue.prototype) === null || _Vue$prototype === void 0 ? void 0 : (_Vue$prototype$$ngVue = _Vue$prototype.$ngVue) === null || _Vue$prototype$$ngVue === void 0 ? void 0 : _Vue$prototype$$ngVue.$injector;
  if (!$injector) throw new Error('Angular $injector not provided, cannot use AngularVueRoutePlugin plugin');
  var $location = $injector.get('$location');
  var $route = $injector.get('$route');
  var $rootScope = $injector.get('$rootScope');
  if (!$location) throw new Error('Angular $location service not available, cannot use AngularVueRoutePlugin plugin');
  if (!$route) throw new Error('Angular $route service not available, cannot use AngularVueRoutePlugin');
  var observableRoute = window.Vue.observable({
    _route: null
  });
  function updateRoute() {
    var _$route$current;
    var fullPath = $location.url();
    var path = $location.path();
    var hash = $location.hash();
    var query = _objectSpread({}, $location.search() || {});
    var params = _objectSpread({}, ((_$route$current = $route.current) === null || _$route$current === void 0 ? void 0 : _$route$current.params) || {});
    observableRoute._route = {
      get fullPath() {
        return fullPath;
      },
      get path() {
        return path;
      },
      get hash() {
        return hash ? "#".concat(hash) : '';
      },
      get query() {
        return _objectSpread({}, query);
      },
      get params() {
        return _objectSpread({}, params);
      }
    };
  }
  $rootScope.$on('$routeUpdate', updateRoute);
  $rootScope.$on('$routeChangeSuccess', updateRoute);
  if (!$route.current) {
    // initial route (at boot time)
    var cancelWatch = $rootScope.$watch(function () {
      return $route.current;
    }, function (currentRoute) {
      if (currentRoute === undefined) return;
      cancelWatch();
      updateRoute();
    });
  }
  updateRoute();
  return {
    install: function install(Vue, options) {
      if (!Vue.prototype.$route) {
        Object.defineProperty(Vue.prototype, '$route', {
          get: function get() {
            return observableRoute._route;
          }
        });
      }
    }
  };
}
export { AngularVueRoutePlugin as default };
//# sourceMappingURL=ng-vue-route-plugin.mjs.map
